<?php
	// module: bx_slider_out (do not remove this comment)
	if (OOAddon::isAvailable('bx_slider')) {
		$out = '';
		$data = array(
			'type' => 'REX_VALUE[18]',
			'images' => explode(',', 'REX_MEDIALIST[1]'),
			'config' => str_replace(array('<br />',"\n","\t"), '', trim('REX_VALUE[20]')),
			'resizeImages' => ('REX_VALUE[1]'),
			'maxWidth' => intval('REX_VALUE[2]'),
			'maxHeight' => intval('REX_VALUE[3]'),
			'slideWidth' => intval('REX_VALUE[4]'),
			'slideHeight' => intval('REX_VALUE[5]')
		);

		// ### Backend
		if ($REX['REDAXO']) {
			if ($data['type'] === 'images' && $data['images'][0] !== '') {
				foreach($data['images'] as $image) {
					$out .= '<img src="index.php?rex_img_type=rex_mediapool_preview&amp;rex_img_file=' . $image .'">';
				}
			}
		}
		
		// ### Frontend
		else {
			
			// Get config
			$config = json_decode(htmlspecialchars_decode($data['config']));
			
			// By slide modules
			if ($data['type'] === 'module') {
				
				// Slides collection
				$slides = array();
				
				// Search slide slices 
				$slice = OOArticleSlice::getFirstSliceForArticle('REX_ARTICLE_ID', 'REX_CLANG_ID');
				if (is_object($slice) === TRUE) {
					do {
						if ('module: bx_slider_slide' === $slice->getValue(20)) {
							$slide = array(
								'id' => 'bx-slide-' . $slice->getId(),
								'type' => $slice->getValue(19),
								'html' => $slice->getValue(1),
								'image' => OOMedia::getMediaByFileName($slice->getMedia(1)),
								'imageCaption' => ($slice->getValue(8) === '1'),
								'imageCaptionText' => $slice->getValue(9),
								'video' => OOMedia::getMediaByFileName($slice->getMedia(2)),
								'videoAutoplay' => ($slice->getValue(3) === '1'),
								'videoLoop' => ($slice->getValue(4) === '1'),
								'videoControls' => ($slice->getValue(5) === '1'),
								'videoPoster' => OOMedia::getMediaByFileName($slice->getMedia(3)),
								'externalUrl' =>  filter_var($slice->getValue(2), FILTER_VALIDATE_URL),
								'internalUrl' => $slice->getLinkUrl(1),
								'iframeUrl' => filter_var($slice->getValue(6), FILTER_VALIDATE_URL),
							);

							// Html content
							if ($slide['type'] === 'html' && $slide['html'] !== '') {					
								$slides[] = $slide['html'];
							} 

							else if ($slide['type'] === 'video' && $slide['video'] && $slide['video']->getExtension() === 'mp4') {
								
								// Config video flag (fidvids.js)
								$data['config'] = str_replace('}', ', "video": true }', $data['config']);
								
								$content  = '<video class="mediaelement-video" id="' . $slide['id'] . '" ';
								$content .= 'style="width:100%;height:100%;" preload="auto" ';
								if ($slide['videoAutoplay']) {
									$content .= 'autoplay="autoplay" ';
									$REX['BX_SLIDER']->setInlineScripts('jQuery("#' . $slide['id'] . '").get(0).play();');
								}
								if ($slide['videoLoop']) {
									$content .= 'loop="loop" ';
								}
								if ($slide['videoControls']) {
									$content .= 'controls="controls" ';
								}
								if ($slide['videoPoster']) {
									$content .= 'poster="' . $slide['videoPoster']->getFullPath() . '" ';
								}
								$content .= 'title="' . htmlspecialchars($title, ENT_QUOTES, 'UTF-8') . '" ';
								$content .= '>';
								$content .= '<source type="video/mp4" src="' . $slide['video']->getFullPath() . '">';
								$content .= '</video>';

								// Add Slide
								$slides[] = $content;
							}
							
							else if ($slide['type'] === 'iframe' && $slide['iframeUrl']) {
								
								// Config video flag (fidvids.js)
								$data['config'] = str_replace('}', ', "video": true }', $data['config']);
								
								// iframe
								$content  = '<iframe src="' . $slide['iframeUrl'] . '" frameborder="0" ';
								$content .= 'webkitAllowFullScreen mozallowfullscreen allowFullScreen>';
								$content .= '</iframe>';
								
								// Add Slide
								$slides[] = $content;
							}

							// Image content
							else if ($slide['type'] === 'image' && $slide['image'] && $slide['image']->isImage()) {
								$content = '';

								// Link
								if ($slide['internalUrl']) {
									$content .= '<a href="' . $slide['internalUrl'] . '">';
								} else if ($slide['externalUrl']) {
									$content .= '<a href="' . $slide['externalUrl'] . '">';
								}
								
								// Caption
								if ($slide['imageCaption']) {
									if ($slide['imageCaptionText'] != '') {
										$title = nl2br($slide['imageCaptionText']);
									} else if ($slide['image']->getDescription()) {
										$title = $slide['image']->getDescription();
									} else {
										$title = $slide['image']->getTitle();
									}
								}
								
								// Image
								$content .= '<img src="' . $slide['image']->getFullPath() . '" ';
								$content .= 'alt="' . htmlspecialchars($slide['image']->getTitle(), ENT_QUOTES, 'UTF-8') . '" ';
								$content .= 'title="' . htmlspecialchars($title, ENT_QUOTES, 'UTF-8') . '" ';
								$content .= 'style="width:100%;height:100%;">';

								if ($slide['internalUrl'] || $slide['externalUrl']) {
									$content .= '</a>';
								}

								$slides[] = $content;
							}
						}
					} while ($slice = $slice->getNextSlice());
				}
				
				foreach($slides as $slide) {
					$out .= '<li>' . $slide . '</li>';
				}
				
				// Unset collections
				unset($slides, $content, $slides, $slice, $slidesModuleId);
			} 
			
			// By medialist (images)
			else if ($data['type'] === 'images' && $data['images'][0] !== '') {
				
				foreach($data['images'] as $image) {
					$media = OOMedia::getMediaByFileName($image);
					
					if ($media && $media->isImage()) {
						$width = $media->getWidth();
						$height = $media->getHeight();
						$src = $media->getFullPath();

						// Resize Images
						if ($data['resizeImages'] && ($data['maxWidth'] || $data['maxHeight'])) {
							if ($width > $height) {
								$height = ceil($height * ($data['maxWidth'] / $width));
								$width = $data['maxWidth'];
							} else {
								$width = ceil($width * ($data['maxHeight'] / $height));
								$height = $data['maxHeight'];
							}
							$src = 'index.php?rex_resize=' . $width . 'w_' . $height . 'h__' .$media->getFileName();
						}
						
						// Caption
						if ($media->getDescription()) {
							$title = nl2br($media->getDescription());
						} else {
							$title = $media->getTitle();
						}
						
						$out .= '<li><img src="' . $src . '" title="' . htmlspecialchars($title, ENT_QUOTES, 'UTF-8') . '" ';
						$out .= 'alt="' . htmlspecialchars($media->getTitle(), ENT_QUOTES, 'UTF-8') . '" ';
						
						// No dimensions on responsive slideshows
						if ($config && !$config->responsive){
							$out .= 'width="' . $width . '" height="' . $height . '" ';
						}
						$out .= '></li>';
					}
				}
				
				// Unset collections
				unset($media, $width, $height, $src, $config);
				
			}
			
			// Set output
			if ($out != '') {
				$out = '<ul id="bx-slideshow-' . 'REX_SLICE_ID' . '" class="bxslider">' . $out . '</ul>';
				
				// Store config
				$REX['ADDON']['bx_slider']['OBJECT']->setConfig('REX_SLICE_ID', $data['config']);
			}
		}
		
		echo $out;
		unset($data);
	}
?>